OGRE: Ogre::ScriptCompilerManager Class Reference - OGRE Documentation

Public Member Functions | Static Public Member Functions | Static Protected Attributes | Private Member Functions | Private Attributes

# Ogre::ScriptCompilerManager Class Reference
[General]

Manages threaded compilation of scripts. More...

`#include <OgreScriptCompiler.h>`

Inheritance diagram for Ogre::ScriptCompilerManager:
[legend]

List of all members.

## Public Member Functions
| ScriptCompilerManager ()
virtual | ~ScriptCompilerManager ()
void | setListener (ScriptCompilerListener *listener)
| Sets the listener used for compiler instances.
ScriptCompilerListener * | getListener ()
| Returns the currently set listener used for compiler instances.
void | addTranslatorManager (ScriptTranslatorManager *man)
| Adds the given translator manager to the list of managers.
void | removeTranslatorManager (ScriptTranslatorManager *man)
| Removes the given translator manager from the list of managers.
void | clearTranslatorManagers ()
| Clears all translator managers.
ScriptTranslator * | getTranslator (const AbstractNodePtr &node)
| Retrieves a ScriptTranslator from the supported managers.
void | addScriptPattern (const String &pattern)
| Adds a script extension that can be handled (e.g. *.material, *.pu, etc.).
const StringVector & | getScriptPatterns (void) const
void | parseScript (DataStreamPtr &stream, const String &groupName)
Real | getLoadingOrder (void) const
virtual const StringVector & | getScriptPatterns (void) const =0
| Gets the file patterns which should be used to find scripts for this class.
virtual void | parseScript (DataStreamPtr &stream, const String &groupName)=0
| Parse a script file.
virtual Real | getLoadingOrder (void) const =0
| Gets the relative loading order of scripts of this type.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static ScriptCompilerManager & | getSingleton (void)
| Override standard Singleton retrieval.
static ScriptCompilerManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.
static ScriptCompilerManager & | getSingleton (void)
static ScriptCompilerManager * | getSingletonPtr (void)
## Static Protected Attributes
static ScriptCompilerManager * | ms_Singleton
## Private Member Functions
| OGRE_THREAD_POINTER (ScriptCompiler, mScriptCompiler)
## Private Attributes
OGRE_AUTO_MUTEX StringVector | mScriptPatterns
ScriptCompilerListener * | mListener
vector < ScriptTranslatorManager * > ::type | mManagers
ScriptTranslatorManager * | mBuiltinTranslatorManager

## Detailed Description

Manages threaded compilation of scripts.

This script loader forwards scripts compilations to a specific compiler instance.

Definition at line 382 of file OgreScriptCompiler.h.

## Constructor & Destructor Documentation

Ogre::ScriptCompilerManager::ScriptCompilerManager | ( |  | ) |

virtual Ogre::ScriptCompilerManager::~ScriptCompilerManager | ( |  | ) | `[virtual]`

## Member Function Documentation

void Ogre::ScriptCompilerManager::addScriptPattern | ( | const String & | pattern | ) |

Adds a script extension that can be handled (e.g. *.material, *.pu, etc.).

void Ogre::ScriptCompilerManager::addTranslatorManager | ( | ScriptTranslatorManager * | man | ) |

Adds the given translator manager to the list of managers.

void Ogre::ScriptCompilerManager::clearTranslatorManagers | ( |  | ) |

Clears all translator managers.

ScriptCompilerListener* Ogre::ScriptCompilerManager::getListener | ( |  | ) |

Returns the currently set listener used for compiler instances.

virtual Real Ogre::ScriptLoader::getLoadingOrder | ( | void |  | ) | const`[pure virtual, inherited]`

Gets the relative loading order of scripts of this type.

Remarks:
  There are dependencies between some kinds of scripts, and to enforce this all implementors of this interface must define a loading order.

Returns:
  A value representing the relative loading order of these scripts compared to other script users, where higher values load later.

Real Ogre::ScriptCompilerManager::getLoadingOrder | ( | void |  | ) | const

Gets the relative loading order of scripts of this type.

Remarks:
  There are dependencies between some kinds of scripts, and to enforce this all implementors of this interface must define a loading order.

Returns:
  A value representing the relative loading order of these scripts compared to other script users, where higher values load later.

virtual const StringVector& Ogre::ScriptLoader::getScriptPatterns | ( | void |  | ) | const`[pure virtual, inherited]`

Gets the file patterns which should be used to find scripts for this class.

Remarks:
  This method is called when a resource group is loaded if you use ResourceGroupManager::_registerScriptLoader.

Returns:
  A list of file patterns, in the order they should be searched in.

const StringVector& Ogre::ScriptCompilerManager::getScriptPatterns | ( | void |  | ) | const

Gets the file patterns which should be used to find scripts for this class.

Remarks:
  This method is called when a resource group is loaded if you use ResourceGroupManager::_registerScriptLoader.

Returns:
  A list of file patterns, in the order they should be searched in.

static ScriptCompilerManager& Ogre::ScriptCompilerManager::getSingleton | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

static ScriptCompilerManager & Ogre::Singleton< ScriptCompilerManager >::getSingleton | ( | void |  | ) | `[static, inherited]`

Definition at line 90 of file OgreSingleton.h.

static ScriptCompilerManager* Ogre::ScriptCompilerManager::getSingletonPtr | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

static ScriptCompilerManager * Ogre::Singleton< ScriptCompilerManager >::getSingletonPtr | ( | void |  | ) | `[static, inherited]`

Definition at line 92 of file OgreSingleton.h.

ScriptTranslator* Ogre::ScriptCompilerManager::getTranslator | ( | const AbstractNodePtr & | node | ) |

Retrieves a ScriptTranslator from the supported managers.

Ogre::ScriptCompilerManager::OGRE_THREAD_POINTER | ( | ScriptCompiler | ,
|  | mScriptCompiler |  |
| ) |  |  | `[private]`

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

void Ogre::ScriptCompilerManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName |
| ) |  |  |

Parse a script file.

Parameters:

  | stream | Weak reference to a data stream which is the source of the script
  | groupName | The name of a resource group which should be used if any resources are created during the parse of this script.

virtual void Ogre::ScriptLoader::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName |
| ) |  |  | `[pure virtual, inherited]`

Parse a script file.

Parameters:

  | stream | Weak reference to a data stream which is the source of the script
  | groupName | The name of a resource group which should be used if any resources are created during the parse of this script.

void Ogre::ScriptCompilerManager::removeTranslatorManager | ( | ScriptTranslatorManager * | man | ) |

Removes the given translator manager from the list of managers.

void Ogre::ScriptCompilerManager::setListener | ( | ScriptCompilerListener * | listener | ) |

Sets the listener used for compiler instances.

## Member Data Documentation

ScriptTranslatorManager* Ogre::ScriptCompilerManager::mBuiltinTranslatorManager`[private]`

Definition at line 397 of file OgreScriptCompiler.h.

ScriptCompilerListener* Ogre::ScriptCompilerManager::mListener`[private]`

Definition at line 391 of file OgreScriptCompiler.h.

vector<ScriptTranslatorManager*>::type Ogre::ScriptCompilerManager::mManagers`[private]`

Definition at line 394 of file OgreScriptCompiler.h.

ScriptCompilerManager * Ogre::Singleton< ScriptCompilerManager >::ms_Singleton`[static, protected, inherited]`

Definition at line 75 of file OgreSingleton.h.

OGRE_AUTO_MUTEX StringVector Ogre::ScriptCompilerManager::mScriptPatterns`[private]`

Definition at line 388 of file OgreScriptCompiler.h.

The documentation for this class was generated from the following file:

- OgreScriptCompiler.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:25:01